import java.io.BufferedReader;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.net.Socket;

public class ComunacacionJugador extends Thread{
	Socket socket;
	public ComunacacionJugador(Socket socket) {
		this.socket = socket;
		this.start();
	}
	
	public void run() {
		boolean continuar = true;
		int turno = 2;
		try {
			BufferedReader bufferEntrada = new BufferedReader(new InputStreamReader(this.socket.getInputStream()));
			PrintWriter bufferSalida = new PrintWriter(new OutputStreamWriter(this.socket.getOutputStream()),true);
			bufferSalida.println(Servidor.mostrarSalas()+"fin");
			int sala = Integer.parseInt(bufferEntrada.readLine())-1;
			if(Servidor.addJugador(sala, this.socket)) {
				bufferSalida.println("Has entrado en la sala");
			}else {
				bufferSalida.println("Error al entrar en la sala");
				socket.close();
				return;
			}
			
			if(Servidor.salas.get(sala).getJugador1().equals(this.socket)) {
				bufferSalida.println("Esperando al segundo jugador");
				synchronized (this.socket) {
					this.socket.wait();
				}
				turno = 1;
				bufferSalida.println("Primero");
				bufferSalida.println(Servidor.salas.get(sala).tablero.getTablero());
				Servidor.salas.get(sala).tablero.colocarFicha(Integer.parseInt(bufferEntrada.readLine()), 
						Integer.parseInt(bufferEntrada.readLine()),turno);
				synchronized (Servidor.salas.get(sala).jugadores[turno%2]) {
					Servidor.salas.get(sala).jugadores[turno%2].notify();
				}
				synchronized (this.socket) {
					this.socket.wait();
				}
			}else {
				bufferSalida.println("Iniciando partida");
				bufferSalida.println("Segundo");
				synchronized (Servidor.salas.get(sala).jugadores[turno%2]) {
					Servidor.salas.get(sala).jugadores[turno%2].notify();
				}
				synchronized (this.socket) {
					this.socket.wait();
				}
			}
			while(continuar) {
				int finalJuego = Servidor.salas.get(sala).tablero.finalJuego();
				if(finalJuego != 0) {
					continuar = false;
					if(finalJuego == turno) {
						bufferSalida.println("v");
					}else {
						bufferSalida.println("f");
					}
					synchronized (Servidor.salas.get(sala).jugadores[turno%2]) {
						Servidor.salas.get(sala).jugadores[turno%2].notify();
					}
				}else {
					bufferSalida.println(Servidor.salas.get(sala).tablero.getTablero());
					Servidor.salas.get(sala).tablero.colocarFicha(Integer.parseInt(bufferEntrada.readLine()), 
							Integer.parseInt(bufferEntrada.readLine()),turno);
					synchronized (Servidor.salas.get(sala).jugadores[turno%2]) {
						Servidor.salas.get(sala).jugadores[turno%2].notify();
					}
					synchronized (this.socket) {
						this.socket.wait();
					}
				}
				
			}
		}catch (Exception e) {
			e.printStackTrace();
		}
	}
}
